package view;

import java.awt.GridLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import model.MultiEditor;
import model.MultiRenderer;
import model.MultiTableModel;
import util.ComboString;

/**
 * @author Nobuo Tamemasa
 * @author Mickal Martin Nevot
 * 
 * @version 1.0.0 11/09/1998
 * @version 1.1.0 28/03/2011
 * @version 1.2.0
 */
public class JFrameMultiComponentTableSample1 extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private static final int FRAME_WIDTH = 400;
	private static final int FRAME_HEIGHT = 160;
	
	private JPanel jContentPane = null;
	private JTable jTable = null;
	
	public JFrameMultiComponentTableSample1() {
		super();
		
		initialize();
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.setTitle("MyJFrameMultiComponentTableSample1"); // On donne un titre  l'application
		this.setSize(FRAME_WIDTH, FRAME_HEIGHT); // On donne une taille  notre fentre
		this.setLocationRelativeTo(null); // On centre la fentre  l'cran
		this.setResizable(false); // On interdit le redimensionnement de la fentre
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); // On dit  l'application de se fermer lors du clic sur la croix
		this.setContentPane(getJContentPane());
	}
	
	/**
	 * This method initializes this.jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (this.jContentPane == null) {
			this.jContentPane = new JPanel();
			this.jContentPane.setLayout(new GridLayout(1, 1));
			
			JScrollPane scroll = new JScrollPane(getJTable());
			this.jContentPane.add(scroll);
		}
		
		return this.jContentPane;
	}
	
	/**
	 * @return javax.swing.JTable
	 */
	private JTable getJTable() {
		if (this.jTable == null) {
			MultiTableModel dm = new MultiTableModel();
			
			dm.setDataVector(
					new Object[][] {
							{ new ComboString("true"), "ComboString", "JLabel",
									"JComboBox" },
							{ new ComboString("false"), "ComboString", "JLabel",
									"JComboBox" },
							{ new Boolean(true), "Boolean", "JCheckBox",
									"JCheckBox" },
							{ new Boolean(false), "Boolean", "JCheckBox",
									"JCheckBox" },
							{ "true", "String", "JLabel", "JTextField" },
							{ "false", "String", "JLabel", "JTextField" } },
					new Object[] { "Component", "Data", "Renderer", "Editor" });
	
			this.jTable = new JTable(dm);
			this.jTable.getColumn("Component").setCellRenderer(new MultiRenderer());
			this.jTable.getColumn("Component").setCellEditor(new MultiEditor());
		}
		
		return this.jTable;
	}
}